# person.rb

class Person 

  require 'json'

  attr_accessor :last_name, :status, :age, :first_name, :person_id
  #attr_reader   :person_id
  def initialize(data)
    @data       = data
    @first_name = @data[:first_name]
    @last_name  = @data[:last_name]
    @age        = @data[:age].to_i
    @status     = @data[:status]
    @person_id  = @data[:person_id].to_i
    @object_id  = @data.fetch([:_id], nil)
  end 
  def name
    return "#{@first_name} #{@last_name}"
  end 
  def intro
    "#{name} is #{@age} years old, and #{@status.downcase}."
  end 
  def to_j
    @data.to_json
  end 
end

module SearchChar

  def get_info(id)
  end
  module_function :get_info
 
  def update_char(data) 
    #person_data = Hash.new
    #person_data[:first_name]  = data['first_name']
    #person_data[:last_name]   = data['last_name']
    #person_data[:age]         = data['age']
    #person_data[:status]      = data['status']
    #person_data[:person_id]   = data['person_id']
    #data.symbolize_keys
    person    = Person.new(data)
    db        = Mongo::Client.new( ['127.0.0.1:27017'], :database => 'people' )
    team      = db[:team]
    #doc = team.find( :person_id => person_data[:person_id] ).find_one_and_replace({
    doc = team.find_one_and_replace( { :person_id => person.person_id },
      {
      :first_name => person.first_name,
      :last_name  => person.last_name,
      :age        => person.age,
      :status     => person.status,
      :person_id  => person.person_id
    })
  end
  module_function :update_char

  def get_all (people_data)
    people = Array.new
    people_data.each { |person| 
      people << Person.new(person)
    }
    return people
  end
  module_function :get_all
end
